#include "VL64Encoding.h"

using namespace System;

System::String^ VL64Encoding::encodeInt(int i)
{
	array<System::Byte>^ wf = gcnew array<Byte>(6);
	int pos = 0;
	int startPos = pos;
	int bytes = 1;
	int negativeMask = i >= 0 ? 0 : 4;
	i = System::Math::Abs(i);
	wf[pos++] = static_cast<System::Byte>(64 + (i & 3));
	for (i >>= 2; i != 0; i >>= 6)
	{
		bytes++;
		wf[pos++] = static_cast<System::Byte>(64 + (i & 0x3f));
	}

	wf[startPos] = static_cast<System::Byte>(wf[startPos] | bytes << 3 | negativeMask);

	return System::Text::Encoding::ASCII->GetString(wf, 0, pos);
}

int VL64Encoding::decodeInt(System::String^ strVal)
{
	array<System::Byte>^ raw = System::Text::Encoding::ASCII->GetBytes(strVal);
	int pos = 0;
	int v = 0;
	bool negative = (raw[pos] & 4) == 4;
	int totalBytes = raw[pos] >> 3 & 7;
	v = raw[pos] & 3;
	pos++;
	int shiftAmount = 2;
	for (int b = 1; b < totalBytes; b++)
	{
		v |= (raw[pos] & 0x3f) << shiftAmount;
		shiftAmount = 2 + 6 * b;
		pos++;
	}

	if (negative == true)
		v *= -1;
	return v;
}