#include <string>
#include <math.h>

#include "VL64Encoding.h"

const char* VL64Encoding::EncodeInt(int nValue)
{
	char* wf = new char[6];
	memset(wf, '\0', 6);

	int pos = 0;
	int startPos = pos;
	int bytes = 1;
	int negativeMask = nValue >= 0 ? 0 : 4;
	nValue = abs(nValue);
	wf[pos++] = 64 + (nValue & 3);

	for (nValue >>= 2; nValue != 0; nValue >>= 6)
	{
		bytes++;
		wf[pos++] = (64 + (nValue & 0x3f));
	}

	wf[startPos] = (wf[startPos] | bytes << 3 | negativeMask);

	return wf;
}

int VL64Encoding::DecodeInt(const char* psValue)
{
	int pos = 0;
	int v = 0;
	bool negative = (psValue[pos] & 4) == 4;
	int totalBytes = psValue[pos] >> 3 & 7;
	v = psValue[pos] & 3;
	pos++;
	int shiftAmount = 2;
	for (int b = 1; b < totalBytes; b++)
	{
		v |= (psValue[pos] & 0x3f) << shiftAmount;
		shiftAmount = 2 + 6 * b;
		pos++;
	}

	if (negative == true)
		v *= -1;
	return v;
}

int VL64Encoding::GetLength(const char *psValue)
{
	return strlen(EncodeInt(DecodeInt(psValue)));
}

int VL64Encoding::GetLength(int nValue)
{
	return strlen(EncodeInt(nValue));
}